program ZlibCompressN64;
{$APPTYPE CONSOLE}
uses
  SysUtils, ZLib, Classes;

function SwapMe2(V: Word): Word;
  asm xchg al,ah end;

function SwapMe4(V: Cardinal): Cardinal;
  asm bswap eax end;

function Ror(V: Cardinal; Shift: Byte): Cardinal;
  asm mov cl,dl; ror eax,cl end;

var
SStream, DStream: TStream;
MemStream: TMemoryStream;
CStream: TCompressionStream;
FileName: String;
Title, Ratio, Align, ByteA: ShortString;
bytecount: Integer;
B: byte;

begin
if ParamCount < 1 then halt;
FileName := ParamStr(1);
Ratio    := ParamStr(3);
Title    := ParamStr(5);
Align    := ParamStr(7);
Align    := ParamStr(7);
ByteA    := ParamStr(9);
Write('Compressing ',FileName,' ... ');
    if ParamStr(2)<>'-c'
    then Writeln(' No compress prefix. File compressed clMax and noheader.');
    if ParamStr(4)<>'-t'
    then Writeln(' No title prefix');
    if ParamStr(6)<>'-A'
    then Writeln(' No Aligned');
SStream := TFileStream.Create(FileName,fmOpenRead);
MemStream := TMemoryStream.Create;
    if Ratio = 'n'
    then CStream := TCompressionStream.Create(clNone, MemStream)
    else
    if Ratio = 'f'
    then CStream := TCompressionStream.Create(clFastest, MemStream)
    else
    if Ratio = 'd'
    then CStream := TCompressionStream.Create(clDefault, MemStream)
    else
    if Ratio = 'm'
    then CStream := TCompressionStream.Create(clMax, MemStream)
    else CStream := TCompressionStream.Create(clMax, MemStream);
CStream.CopyFrom(SStream,SStream.Size);
CStream.Free;
    if  Title = 'BK'
    then begin
         DStream := TFileStream.Create(FileName+'.BKzip',fmCreate);
         bytecount := SwapMe2(4466);
         DStream.Write(bytecount, 2);
         bytecount := SwapMe4(SStream.Size);
         DStream.Write(bytecount, 4)
         end
    else
    if Title = 'BT'
    then begin
         DStream := TFileStream.Create(FileName+'.BTzip',fmCreate);
         if SStream.Size mod 16 >0
         then bytecount := 1 + SStream.Size div 16
         else bytecount := SStream.Size div 16;
         bytecount := SwapMe2(bytecount);
         DStream.Write(bytecount, 2)
         end
    else
    if Title = 'Gold'
    then begin
         DStream := TFileStream.Create(FileName+'.Goldzip',fmCreate);
         bytecount := SwapMe2(4466);
         DStream.Write(bytecount, 2)
         end
    else
    if Title = 'PD'
    then begin
         DStream := TFileStream.Create(FileName+'.PDzip',fmCreate);
         bytecount := SwapMe2(4467);
         DStream.Write(bytecount, 2);
         bytecount := SwapMe4(SStream.Size);
         bytecount := Ror(bytecount, 8);
         DStream.Write(bytecount, 3)
         end
    else
    if Title = 'CBFD'
    then begin
         DStream := TFileStream.Create(FileName+'.CBFDzip',fmCreate);
         bytecount := SwapMe4(SStream.Size);
         DStream.Write(bytecount, 4)
         end
    else
    if Title = 'JFG'
    then begin
         DStream := TFileStream.Create(FileName+'.JFGzip',fmCreate);
         bytecount := SStream.Size;
         DStream.Write(bytecount, 4);
         bytecount := 9;
         DStream.Write(bytecount, 1)
         end
    else DStream := TFileStream.Create(FileName+'.Nudezip',fmCreate);
MemStream.Seek(2, soBeginning);
DStream.CopyFrom(MemStream,MemStream.Size-6);
SStream.Free;
MemStream.Free;
  if Align = '4'
  then bytecount := 4
  else
  if Align = '8'
  then bytecount := 8
  else
  if Align = '16'
  then bytecount := 16
  else
  if Align = '32'
  then bytecount := 32
  else bytecount := 1;
  if ByteA = 'AA'
  then B := $AA
  else B := 0;
while DStream.Size mod bytecount > 0 do DStream.Write(B, 1);
DStream.Free;
Writeln('Done')
end.

